# Test manipulating sql// objects.

use strict;
use Test::More 'no_plan';
use Data::Dumper;
use SQL::Interpolate FILTER => 1, qw(:all);
require 't/lib.pl';

our $fake_mysql_dbh;

my $x = 5;
my $v = ['one', 'two'];
my $s1 = sql[SELECT * FROM mytable WHERE x = $x];
print Dumper($s1);

is(&sql_str(sql[SELECT * FROM mytable WHERE x = $x]),
   "[ 'SELECT * FROM mytable WHERE x = ', \\5 ]");

is(&sql_str(sql[SELECT * FROM mytable WHERE x IN $v]),
   "[ 'SELECT * FROM mytable WHERE x IN ', \\[ 'one', 'two' ] ]");

is(&sql_str(sql[SELECT * FROM mytable LIMIT(start => 5, count => 10)]),
   "[ 'SELECT * FROM mytable ', 'LIMIT', \\10, 'OFFSET', \\5 ]");

is(&sql_str($fake_mysql_dbh,
   sql[SELECT * FROM mytable LIMIT(start => 5, count => 10)]),
   "[ 'SELECT * FROM mytable ', 'LIMIT', \\5, ',', \\10 ]");

# concat

is(&sql_str(sql[SELECT * FROM mytable WHERE x =] . \$x . "AND y=z"),
   "[ 'SELECT * FROM mytable WHERE x =', \\5, 'AND y=z' ]");

is(&sql_str(sql[SELECT * FROM mytable WHERE x IN ] . $v),
   "[ 'SELECT * FROM mytable WHERE x IN ', [ 'one', 'two' ] ]");
